<template>
       <b-card class="animated fadeIn">
                    <div slot="header">
                <span class="custom-card-title">Danh sách nhân viên</span>
               <b-button variant="primary" class="float-right" to="/users/create"><i class="fa fa-plus"></i> Tạo mới</b-button>
           </div>
      <b-table hover 
               :items="salesmen" 
               :fields="fields"
               :current-page="currentPage"
               :per-page="perPage">
          <span slot="status_label" slot-scope="data" v-html="data.value"></span>
        <template slot="actions" slot-scope="row">
        <b-button size="sm" variant="success" :to="{ name: 'Cập nhật nhân viên', params: { saleId: row.item.id}}">Edit</b-button>
       <b-button size="sm" :variant="row.item.status == 2 ? 'warning' : 'danger'" @click.stop="confirmAction(row.item)">{{ row.item.status == 2 ? 'Active' : 'Deactive' }}</b-button>
      </template>       
      </b-table>
          <b-row>
      <b-col md="6" class="my-1">
        <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
      </b-col>
    </b-row>
       </b-card>

</template>

<script>
import { http } from "../../services";
import { alerts } from "../../utils";
export default {
  data() {
    return {
      fields: [
        {
          key: "id",
          label: "Mã NV",
          sortable: true
        },
        {
          key: "name",
          label: "Họ tên",
          sortable: true
        },
        {
          key: "email",
          label: "Email",
          sortable: true
        },
        {
          key: "agencies_count",
          label: "Số đại lý",
          sortable: true
          // Variant applies to the whole column, including the header and footer
          // variant: 'danger'
        },
        {
          key: "payments_count",
          label: "Tổng số GĐ",
          sortable: true
          // Variant applies to the whole column, including the header and footer
          // variant: 'danger'
        },
        {
          key: "status_label",
          label: "Trạng thái",
          sortable: true
        },
        {
          key: "created_at",
          label: "Ngày tạo",
          sortable: true,
          formatter: value => {
            return this.$moment(value).format("DD/MM/YYYY HH:mm:ss");
          }
        },
        {
          key: "actions",
          label: "Actions"
        }
      ],
      salesmen: [],
      selectedSalesman: null,
      currentPage: 1,
      perPage: 20,
      totalRows: 0,
      pageOptions: [5, 10, 15]
    };
  },
  created() {
    this.fetchSalesmen();
  },
  methods: {
    fetchSalesmen() {
      http.get("/salesman", response => {
        this.salesmen = response.data;
        this.totalRows = response.data.length;
      });
    },
    async toggleActiveState() {
      return new Promise((resolve, reject) => {
        http.post(
          "/user/toggleActive",
          { id: this.selectedSalesman.id },
          response => {
            return resolve(response.data);
          }
        );
      });
    },
    confirmAction(salesman) {
      this.selectedSalesman = salesman;
      let msg = "Bạn chắc chắn muốn khóa tài khoản này?";
      if (salesman.status == 2) {
        msg = "Bạn chắc chắn muốn kích hoạt tài khoản này?";
      }
      alerts.ajaxConfirm(
        msg,
        "warning",
        this.toggleActiveState,
        this.fetchSalesmen
      );
    }
  }
};
</script>